unit JpegMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ExtDlgs;

type


  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    LabeledEdit1: TLabeledEdit;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image2: TImage;
    Image1: TImage;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses  WinCodec, ActiveX,
      Vcl.imaging.Jpeg,
      GDIPOBJ, GDIPAPI, GDIPUTIL;

{$R *.dfm}

//var
//  FImageFilePath : string;

// uses  WinCodec, ActiveX ɂ܂
procedure TForm1.Button1Click(Sender: TObject);
var
  WICImage        : TWICImage;
  Encoder         : IWICBitmapEncoder;
  Frame           : IWICBitmapFrameEncode;
  Factory         : IWICImagingFactory;
  LStream         : IWICStream;
  Palette         : IWICPalette;
  LStreamAdapter  : TStreamAdapter;
  PixelFormat     : TGUID;
  Memstm          : TMemoryStream;
  Option          : TPropBag2;
  Props           : IPropertyBag2;
  Value           : TPropVariant;
  rtn             : Integer;
  fltVal          : Extended;
begin
  val(LabeledEdit1.Text, fltVal, rtn);
  if rtn <> 0 then begin
    application.MessageBox('kx̒lɊԈႢ܂B', '', 0);
    exit;
  end;
  if (fltVal <= 0) or (fltVal > 1) then begin
    application.MessageBox('kx̒l 0 < X <= 1 ɂĉB', '', 0);
    exit;
  end;
// 摜Ɗ֘At
//  Image2.Picture.Assign(nil);                 // Image2 ֘At̉
  Image2.Picture.Bitmap.Height := Image1.Picture.Bitmap.Height;
  Image2.Picture.Bitmap.Width  := Image1.Picture.Bitmap.Width;

  WICImage := TWICImage.Create;
  WICImage.Assign(Image1.Picture.Bitmap);
// o͐̍쐬(TMemoryStream)
  Memstm := TMemoryStream.Create;
  Memstm.Clear;
  LStreamAdapter := TStreamAdapter.Create(Memstm);
  IUnknown(LStreamAdapter)._AddRef;
  try
// CLSID_WICImagingFactory  t@Ng̐
    if Failed(CoCreateInstance(CLSID_WICImagingFactory, nil,
        CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER, IUnknown, Factory)) then exit;
    Factory.CreateStream(LStream);
    LStream.InitializeFromIStream(LStreamAdapter);
// EncoderJpeg`pƂč쐬
    Factory.CreateEncoder(GUID_ContainerFormatJpeg, guid_null, Encoder);
    Encoder.Initialize(LStream, WICBitmapEncoderNoCache);
// t[쐬
    Encoder.CreateNewFrame(Frame, Props);
// jpeg Qualityw肷
    Option.pstrName := 'ImageQuality';
    Option.dwType := 1;         // data
    Option.dwHint := 0;         // 
    Value.vt := VT_R4;
    Value.fltVal := fltVal;     // 0.`1
    rtn := Props.Write(1, @Option, @Value);
    if rtn = 0 then begin
//  摜f[^ɕKvȏt
      Frame.Initialize(Props);
      WICImage.Handle.GetPixelFormat(PixelFormat);
      Frame.SetPixelFormat(PixelFormat);
      Frame.SetSize(WICImage.Width, WICImage.Height);
      Factory.CreatePalette(Palette);
      WICImage.Handle.CopyPalette(Palette);
      Frame.SetPalette(Palette);
      Frame.WriteSource(WICImage.Handle, nil);
      Frame.Commit;
      Encoder.Commit;
// MemoryStreamǂݍ 摜̕\
      Memstm.Position := 0;                         // ǂݏoʒuXg[擪ɃZbg
      WICImage.LoadFromStream(Memstm);
//      Image2.Picture.Assign(WICImage);
      Image2.Canvas.Draw(0, 0, WICImage);           // Jpeg摜̕\
//  t@CƂĕۑ
//      Memstm.Position := 0;
//      Memstm.SaveToFile('D:\test.jpg');
    end;
  finally
    Memstm.Free;
    IUnknown(LStreamAdapter)._Release;
    if Assigned(WICImage) then FreeAndNil(WICImage);
  end;
end;

// Uses JPEG@ɂ܂
procedure TForm1.Button3Click(Sender: TObject);
var
  jp              : TJPEGImage;
  LMemoryStream   : TMemoryStream;
  Ch              : integer;
  Vale            : double;
begin
  val(LabeledEdit2.Text, Vale, ch);
  if ch <> 0 then begin
    application.MessageBox('kx̒lɊԈႢ܂B', '', 0);
    exit;
  end;
  if (Vale <= 0) or (Vale > 100) then begin
    application.MessageBox('kx̒l 0 < X <= 100 ɂĉB', '', 0);
    exit;
  end;
//  Image2.Picture.Assign(nil);                   // Image2 ֘At̉
  Image2.Picture.Bitmap.Height := Image1.Picture.Bitmap.Height;
  Image2.Picture.Bitmap.Width  := Image1.Picture.Bitmap.Width;
  jp :=TJPEGImage.Create;
  LMemoryStream := TMemoryStream.Create;
  LMemoryStream.Clear;
  try
    with jp do begin
      Assign(Image1.Picture.Bitmap);            // BitmapJPEGɊ֘At
      CompressionQuality := round(Vale);        // k 1`100
      DIBNeeded;                                // JPEGImageɃrbg}bv쐬
      Compress;                                 // rbg}bvJPEGImage쐬
      SaveToStream(LMemoryStream);              // Xg[ɕۑ
//      SaveToFile('D:\Test.jpg' );
      LMemoryStream.Position := 0;              // ǂݏoʒuXg[擪ɃZbg
      LoadFromStream(LMemoryStream);
    end;
//    Image2.Picture.Assign(JP);
    Image2.Canvas.Draw(0, 0, jp);               // Jpeg摜̕\
//    LMemoryStream.Position := 0;
//    LMemoryStream.SaveToFile('D:\test.jpg');    // t@C֕ۑ
  finally
    jp.free;
    LMemoryStream.Free;
  end;
end;

{
type
  DEncoderParameter = record
    Guid : TGUID;           // GUID of the parameter
    NumberOfValues : ULONG; // Number of the parameter values
    Type_ : ULONG;          // Value type, like ValueTypeLONG etc.
    Value : Pointer;        // A pointer to the parameter values
  end;

  TDEncoderParameter = DEncoderParameter;
  DEncoderParameters = record
    Count : UINT;           // Number of parameters in this structure
    Parameter : array[0..1] of TDEncoderParameter; // Parameter values
  end;

  TDEncoderParameters = DEncoderParameters;
//  PDEncoderParameters = ^TDEncoderParameters;
}

// uses GDIPOBJ, GDIPAPI, GDIPUTILɂ܂
procedure TForm1.Button4Click(Sender: TObject);
var
  LObjWidth       : Integer;
  LObjHeight      : Integer;
  LGPImage        : TGPImage;
  LGPGraphic      : TGPGraphics;
  LEncoderParams  : TEncoderParameters;
//  LEncoderParams  : TDEncoderParameters;
  LMemoryStream, GMemoryStream  : TMemoryStream;
  LIStrema        : IStream;
  LImageGUID      : TGUID;
  FJPEGQuality    : Cardinal;
//  transformation  : TEncoderValue;
  Ch              : integer;
  Vale            : double;
begin
  val(LabeledEdit3.Text, Vale, ch);
  if ch <> 0 then begin
    application.MessageBox('kx̒lɊԈႢ܂B', '', 0);
    exit;
  end;
  if (Vale <= 0) or (Vale > 100) then begin
    application.MessageBox('kx̒l 0 < X <= 100 ɂĉB', '', 0);
    exit;
  end;
  Image2.Picture.Assign(nil);                   // Image2 ֘At̉ Ȃƕ`悳܂
//  transformation := EncoderValueTransformRotate90;
  FJPEGQuality := round(Vale);
  // 摜t@CTGPImagẽCX^X𐶐Dƍ擾
//  LGPImage    := TGPImage.Create(FImageFilePath);
  // Image1̉摜Xg[ɕۑ
  GMemoryStream := TMemoryStream.Create;
  Image1.Picture.Bitmap.SaveToStream(GMemoryStream);
  // Xg[ɕۑImage1摜TGPImagẽCX^X𐶐
  LIStrema := TStreamAdapter.Create(GMemoryStream);
  LGPImage := TGPBitmap.Create(LIStrema);
  LObjWidth   := LGPImage.GetWidth;
  LObjHeight  := LGPImage.GetHeight;
  // image2rbg}bvTCYݒ
  image2.Picture.Bitmap.SetSize(LObjWidth, LObjHeight);
  // LGPGraphic̕`image2ɐݒ
  LGPGraphic := TGPGraphics.Create(image2.Canvas.Handle);
  // JPEG̕i֌W̒lTEncoderParametersR[h^̊eo[ɃZbg
  with LEncoderParams do begin
    Count := 1;
//    Count := 2;
    Parameter[0].Guid           := EncoderQuality;
    Parameter[0].Type_          := EncoderParameterValueTypeLong;
    Parameter[0].NumberOfValues := 1;
    Parameter[0].Value          := @FJPEGQuality;
//    Parameter[1].Guid           := EncoderTransformation;
//    Parameter[1].Type_          := EncoderParameterValueTypeLong;
//    Parameter[1].NumberOfValues := 1;
//    Parameter[1].Value          := @transformation;
  end;
  // JpegpXg[𐶐
  LMemoryStream := TMemoryStream.Create;
  try
    // Xg[Ɉkۑ
    GetEncoderClsid('image/jpeg', LImageGUID);
    LGPImage.Save(TStreamAdapter.Create(LMemoryStream), LImageGUID, @LEncoderParams);
    // t@Cɕۑ
//    LGPImage.Save('D:\Test.jpg', LImageGUID, @LEncoderParams);
    LGPImage.Free;                                                // LGPImage
    // Xg[ɕۑJPEG摜TGPImagẽCX^X𐶐
    LIStrema := TStreamAdapter.Create(LMemoryStream);
    LGPImage := TGPBitmap.Create(LIStrema);
    LGPGraphic.DrawImage(LGPImage, 0, 0, LObjWidth, LObjHeight);  // Jpeg摜̕\
//    LMemoryStream.Position := 0;
//    LMemoryStream.SaveToFile('D:\test.jpg');    // t@C֕ۑ
  finally
    LMemoryStream.Free;
    GMemoryStream.Free;
  end;
  if Assigned(LGPGraphic) then FreeAndNil(LGPGraphic);
  if Assigned(LGPImage) then FreeAndNil(LGPImage);
//  LGPGraphic.Free;
//  LGPImage.Free;
end;

// t@C̃I[v
procedure TForm1.Button2Click(Sender: TObject);
var
  WICImage        : TWICImage;
begin
// C[Wǂݍ
  OpenPictureDialog1.Filter := 'C[Wt@C|*.jpg;*.jpeg;*.tif;*.tiff;*.png;*.gif;*.bmp;*.wdp';
  if OpenPictureDialog1.Execute then begin                  // t@Cw肳ꂽ
    WICImage := TWICImage.Create;
    WICImage.LoadFromFile(OpenPictureDialog1.FileName);
  end
  else
    exit;                                                   // t@CIȂI
// ͉摜̕\
  Image1.Picture.Bitmap.SetSize(WICImage.Width, WICImage.Height);
  Image1.Canvas.Draw(0, 0, WICImage);
//  Image1.Picture.Assign(WICImage);                        // Assign Image1.Picture.Bitmapd gps

//  FImageFilePath := OpenPictureDialog1.FileName;
  Button1.Enabled := True;
  Button3.Enabled := True;
  Button4.Enabled := True;
  if Assigned(WICImage) then FreeAndNil(WICImage);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Enabled := False;
  Button3.Enabled := False;
  Button4.Enabled := False;
end;


end.
